<template>
  <div>
    <p v-if="error">{{ t("error_message") }}</p>
    <template v-if="configured">
      <canvas ref="canvas" width="400" height="300"></canvas>
      <img alt="IP Cam" :src="camUrl" width="100%" ref="image"/>
    </template>
    <p v-else>{{ t("configure_message") }}</p>
  </div>
</template>

<script>
module.exports = {
  name: "ip_cam",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    currentDimensions: {
      type: Object,
      required: true
    },
    sourcesConfigured: {
      type: Boolean,
      required: false
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    }
  },
  data: function () {
    return {
      drawIntervalId: undefined,
      streaming: false,
      error: false,
      streamReloaderId: undefined,
    };
  },
  watch: {
    configured: {
      immediate: true,
      handler: function (newVal, _oldVal) {
        switch (newVal) {
          case true:
            this.error = false;
            this.$nextTick(function () {
              this.startStream();
            });
            break;
          case false:
            this.stopStream();
            break;
        }
      }
    },
    "currentSettings.reloadStream": {
      immediate: true,
      handler: function (newVal, _oldVal) {
        switch (newVal) {
          case true:
            window.clearInterval(this.streamReloaderId);
            this.streamReloaderId = window.setInterval(() => {
              this.stopStream();
              this.startStream();
            }, 3600000);
            break;
          case false:
            window.clearInterval(this.streamReloaderId);
            break;
          default:
            break;
        }
      }
    }
  },
  beforeDestroy: function () {
    this.stopStream();
  },
  computed: {
    configured: function () {
      if (this.currentSettings.url.length === 0) return false;

      if (this.currentSettings.requiresAuth) {
        if (this.currentSettings.user.length === 0 || this.currentSettings.password.length === 0) {
          return false;
        }
      }
      return true;
    },
    camUrl: function () {
      if (!this.configured) return "";

      try {
        let url = new URL(this.currentSettings.url);
        if (this.currentSettings.requiresAuth) {
          url = new URL("http://localhost/authproxy"); // Use authproxy to prevent CORS warnings.
          url.search = `url=${this.currentSettings.url}`;
          url.username = this.currentSettings.user;
          url.password = this.currentSettings.password;
        }
        return url.toString();
      } catch (error) {
        return "";
      }
    }
  },
  methods: {
    startStream: function () {
      if (this.streaming) return;
      /*
    WPE WebKit currently (2020-01-10) has a flicker issue with multipart/x-mixed-replace content type streams. This draws the image's content onto a canvas element while the original element is hidden.
    Adapted from https://github.com/WebPlatformForEmbedded/WPEWebKit/issues/569#issuecomment-459614629
    */

      const canvas = this.$refs.canvas;
      const ctx = canvas.getContext("2d");
      const img = this.$refs.image;

      ctx.imageSmoothingEnabled = true;

      function draw() {
        ctx.drawImage(img, 0, 0, canvas.width, canvas.height);
      }

      img.onload = () => {
        draw();
        this.drawIntervalId = window.setInterval(draw, 30);
      };
      img.onerror = event => {
        this.drawIntervalId = clearInterval(this.drawIntervalId);
        // element.onerror doesn't provide error reason, so we just display a generic message.
        this.error = true;
      };

      this.streaming = true;
    },
    stopStream: function () {
      if (!this.streaming) return;

      this.drawIntervalId = clearInterval(this.drawIntervalId);
      this.streaming = false;
      // Bruteforce workaround for WebKit bug https://bugs.webkit.org/show_bug.cgi?id=6656 and/or https://bugs.webkit.org/show_bug.cgi?id=35377 – MJPEG streams would continue downloading the image in the background, thus bloating the local cache.
      window.location.reload();
    }
  },
  locales: {
    enGb: {
      configure_message: "Please configure in settings",
      error_message:
          "Starting the camera stream failed. Typo in the URL? For authenticated streams, please also check user/password."
    },
    deDe: {
      configure_message: "Bitte in den Einstellungen konfigurieren",
      error_message:
          "Starten des Kamera-Streams fehlgeschlagen. Tippfehler in der URL? Bei passwortgeschützten Streams bitte auch Nutzer/Passwort prüfen."
    },
    frFr: {
      configure_message: "Veuillez configurer dans les paramètres",
      error_message:
          "Le démarrage du flux de la caméra a échoué. Une faute de frappe dans l'URL? Pour les flux authentifiés, veuillez également vérifier l'utilisateur / mot de passe.",
    },
    esEs: {
      configure_message: "Por favor, configure en la configuración",
      error_message:
          "Error al iniciar la transmisión de la cámara. ¿Error tipográfico en la URL? Para transmisiones autenticadas, verifique también usuario / contraseña."
    },
    plPl: {
      configure_message: "Proszę skonfigurować w ustawieniach",
      error_message:
          "Uruchomienie strumienia z kamery nie powiodło się. Literówka w adresie URL? W przypadku strumieni uwierzytelnionych sprawdź również użytkownika / hasło."
    },
    koKr: {
      configure_message: "설정에서 구성하십시오",
      error_message:
          "카메라 스트림을 시작하지 못했습니다. URL에 오타가 있습니까? 인증 된 스트림의 경우 사용자 / 비밀번호도 확인하세요."
    }
  }
};
</script>
<style scoped>
img {
  visibility: hidden;
}

canvas {
  width: 100%;
  height: 100%;
}
</style>
